//-----------------------------LICENSE NOTICE------------------------------------
//  This file is part of CPCtelera: An Amstrad CPC Game Engine
//  Copyright (C) 2015 ronaldo / Fremos / Cheesetea / ByteRealms (@FranGallegoBR)
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU Lesser General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//------------------------------------------------------------------------------

#include <cpctelera.h>
#include "juego.h"
#include "inicio.h"
#include "personajes.h"
#include "sprites/cartel.h"

u8 variable;

u8 devolverVariable(){
   return variable;
}

void startMenu () {
   cpct_drawSolidBox(cpctm_screenPtr(CPCT_VMEM_START,  0, 66), 0xC0, 40, 134);
   cpct_drawSolidBox(cpctm_screenPtr(CPCT_VMEM_START, 40, 66), 0xC0, 40, 134);
   while (1) {
      u16 c = 1000;  // 20 secs

      cpct_drawStringM0 ("PRESS ENTER TO PLAY"
               			,  cpctm_screenPtr(CPCT_VMEM_START, 1, 140)
                        ,  15, 1);

      while (--c) {
        variable++;
      	cpct_scanKeyboard();
         if (cpct_isAnyKeyPressed()){
            if(cpct_isKeyPressed(Key_Return))
               return;
         }
         cpct_waitVSYNC();
      }
   }
}

void gameOver() {
   u16 c = 1500;  // 30 secs

   while (--c) {
      cpct_drawStringM0 ("GAME OVER"
                        ,  cpctm_screenPtr(CPCT_VMEM_START, 20, 70)
                        ,  c & 0x0F, 1);
      cpct_drawStringM0 ("PRESS ENTER"
                        ,  cpctm_screenPtr(CPCT_VMEM_START, 15, 100)
                        ,  c & 0x0F, 1);
      //cpct_scanKeyboard_if();
      if (cpct_isAnyKeyPressed()){
         if(cpct_isKeyPressed(Key_Return))
         return;
      }
      cpct_waitVSYNC();
   }
}

u8 credits(){
    u16 c = 1500;  // 30 secs
   if(finJuego()){
      while (--c) {
         cpct_drawStringM0 ("CREDITS"
                           ,  cpctm_screenPtr(CPCT_VMEM_START, 25, 75)
                           ,  c & 0x0F, 1);
         cpct_drawStringM0 ("Game Developers"
                           ,  cpctm_screenPtr(CPCT_VMEM_START, 10, 100)
                           ,  1, 15);
         cpct_drawStringM0 ("Mateo Bernal"
                           ,  cpctm_screenPtr(CPCT_VMEM_START, 5, 125)
                           ,  15, 1);
         cpct_drawStringM0 ("Adrian Gonzalez"
                           ,  cpctm_screenPtr(CPCT_VMEM_START, 5, 145)
                           ,  15, 1);
         cpct_drawStringM0 ("Roberto Martinez"
                           ,  cpctm_screenPtr(CPCT_VMEM_START, 5, 165)
                           ,  15, 1);
         //cpct_scanKeyboard_if();
         if (cpct_isAnyKeyPressed()){
            if(cpct_isKeyPressed(Key_Return))
            return 0;
         }
         cpct_waitVSYNC();
         }
         return 0;
   }
   else{
      return 1;
   }
}

void startGame(){
	inicializarPJS();
}
void drawGame(){
	dibujarPJS();
}
u8 updateGame() {
   cpct_waitVSYNC();
   if(getVida() >0 && finJuego() == 0 )
   	return 1;
   else
   	return 0;
}