//-----------------------------LICENSE NOTICE------------------------------------
//  This file is part of CPCtelera: An Amstrad CPC Game Engine
//  Copyright (C) 2015 ronaldo / Fremos / Cheesetea / ByteRealms (@FranGallegoBR)
//
//  This program is free software: you can redistribute it and/or modify
//  it under the terms of the GNU Lesser General Public License as published by
//  the Free Software Foundation, either version 3 of the License, or
//  (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU Lesser General Public License for more details.
//
//  You should have received a copy of the GNU Lesser General Public License
//  along with this program.  If not, see <http://www.gnu.org/licenses/>.
//------------------------------------------------------------------------------


#include <types.h>


typedef struct {
	u8  mira;
	u8* sprite;
} TFrame;

typedef struct{
	u8  x,y;
	u8  px,py;
	u8* sprite;
} TBombilla;

typedef struct{
	u8  x,y;
	u8  px,py;
	u8 mover;
	TFrame* frame;
	u8 nframe;
	u8 mira;
	u8 estado;
	u8 prev_estado;
	u8 vida;
} TProta;

typedef struct{
	u8  x,y;
	u8  px,py;
	u8* sprite;
	u8  muestro;
	u8 	vivo1;
	u8 	vivo2;
	u8 	vivo3;
	u8 	vivo4;
	u8 	vivo5;
	u8	vida;
	u8 valentia;
	u8* colisionI;
	u8* colisionAr;
	u8* colisionD;
	u8* colisionAb;
	u8 semaf;
	u8 distx;
	u8 disty;
} TBicho;

typedef struct {
   u8 x,y;
   u8 px,py;
   u8 existe;
   u8 mira;
} TBala;








///////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////
/// EXPORTED PUBLIC FUNCTIONS
///////////////////////////////////////////////////////////////
///////////////////////////////////////////////////////////////
u8 getRand();

void inicializarPJS();

void dibujarPJS();

u8 finJuego();

u8 getVida();

void dibujarBombilla();

void inicializarMapa2();

void inicializarMapa3();

void inicializarMapa4();

void inicializarMapa6();

void inicializarMapa7();

void dibujarMapa();

void girarFrame() ;

void asignarFrame(TFrame **animacion) ;

void seleccionarSpriteProta();

void dibujarProta();

void borrarProta();

void redibujarProta();

void dibujarBicho1(u8 num2);

void borrarBicho(u8 muerto);

void moverBicho1(u8 mover1);

void bichoAtaca(u8 mover1);

void bichoPatrullar(u8 mover1);

void bichoHuye(u8 mover1);

u8* obtenerTilePtr(u8 x, u8 y);

void avanzarMapa();

void comprobarColisionProtaBicho(u8 vida);

void retrocederMapa();

void ajustarAlSuelo();

u8 haySuelo();

u8 hayTecho() ;

u8 hayParedI();

u8 hayParedD() ;

void moverIzquierda();

void moverDerecha();

void moverAbajo();

void moverArriba();

u8 compruebaTeclas(const cpct_keyID* k, u8 numk);

void quieto_entrar();

void dibujarDisparo();

void borrarDisparo();

u8 disparando();

void redibujarDisparo();

void disparar();

void quieto();

void andando_entrar(u8 mirar, u8 num);

void andando_animar(u8 mirar);

void andando();

void ejecutarEstado();
